// Code generated by mockery v2.20.0. DO NOT EDIT.

package mockclients

import (
	context "context"

	mock "github.com/stretchr/testify/mock"

	types "gitlab.com/infor-cloud/martian-cloud/tharsis/tharsis-sdk-go/pkg/types"
)

// TerraformProviderPlatformMirror is an autogenerated mock type for the TerraformProviderPlatformMirror type
type TerraformProviderPlatformMirror struct {
	mock.Mock
}

// DeleteProviderPlatformMirror provides a mock function with given fields: ctx, input
func (_m *TerraformProviderPlatformMirror) DeleteProviderPlatformMirror(ctx context.Context, input *types.DeleteTerraformProviderPlatformMirrorInput) error {
	ret := _m.Called(ctx, input)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.DeleteTerraformProviderPlatformMirrorInput) error); ok {
		r0 = rf(ctx, input)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetProviderPlatformMirror provides a mock function with given fields: ctx, input
func (_m *TerraformProviderPlatformMirror) GetProviderPlatformMirror(ctx context.Context, input *types.GetTerraformProviderPlatformMirrorInput) (*types.TerraformProviderPlatformMirror, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.TerraformProviderPlatformMirror
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetTerraformProviderPlatformMirrorInput) (*types.TerraformProviderPlatformMirror, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetTerraformProviderPlatformMirrorInput) *types.TerraformProviderPlatformMirror); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.TerraformProviderPlatformMirror)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetTerraformProviderPlatformMirrorInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetProviderPlatformMirrorsByVersion provides a mock function with given fields: ctx, input
func (_m *TerraformProviderPlatformMirror) GetProviderPlatformMirrorsByVersion(ctx context.Context, input *types.GetTerraformProviderPlatformMirrorsByVersionInput) ([]types.TerraformProviderPlatformMirror, error) {
	ret := _m.Called(ctx, input)

	var r0 []types.TerraformProviderPlatformMirror
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetTerraformProviderPlatformMirrorsByVersionInput) ([]types.TerraformProviderPlatformMirror, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetTerraformProviderPlatformMirrorsByVersionInput) []types.TerraformProviderPlatformMirror); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]types.TerraformProviderPlatformMirror)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetTerraformProviderPlatformMirrorsByVersionInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// UploadProviderPlatformPackageToMirror provides a mock function with given fields: ctx, input
func (_m *TerraformProviderPlatformMirror) UploadProviderPlatformPackageToMirror(ctx context.Context, input *types.UploadProviderPlatformPackageToMirrorInput) error {
	ret := _m.Called(ctx, input)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.UploadProviderPlatformPackageToMirrorInput) error); ok {
		r0 = rf(ctx, input)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

type mockConstructorTestingTNewTerraformProviderPlatformMirror interface {
	mock.TestingT
	Cleanup(func())
}

// NewTerraformProviderPlatformMirror creates a new instance of TerraformProviderPlatformMirror. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewTerraformProviderPlatformMirror(t mockConstructorTestingTNewTerraformProviderPlatformMirror) *TerraformProviderPlatformMirror {
	mock := &TerraformProviderPlatformMirror{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
